Procedure.s addpsnrssim()
  temp.s = ""
  If GetGadgetState(#check_psnr)=0
    temp.s=temp.s+" --no-psnr"
  EndIf
  If GetGadgetState(#check_ssim)=0
    temp.s=temp.s+" --no-ssim"
  EndIf
  ProcedureReturn temp.s
EndProcedure

Procedure.s addcqm()
  If GetGadgetText(#combo_q)="flat" Or GetGadgetText(#combo_q)="jvt"
    ProcedureReturn " --cqm "+GetGadgetText(#combo_q)
  Else
    ProcedureReturn " --cqmfile "+GetGadgetText(#combo_q)
  EndIf
EndProcedure

Procedure.s addippb()
  temp.s=" --ipratio "+StrF((Val(GetGadgetText(#String_4))/100+1))
  temp.s=temp.s+" --pbratio "+StrF((Val(GetGadgetText(#String_5))/100+1))
  ProcedureReturn temp.s
EndProcedure

Procedure.s addanalyses()
  temp.s=" -A "
  If GetGadgetState(#CheckBox_1)
    temp=temp+"p8x8,"
    If GetGadgetState(#CheckBox_3)
      temp=temp+"p4x4,"
    EndIf
  EndIf
  If GetGadgetState(#CheckBox_2)
    temp=temp+"b8x8,"
  EndIf
  If GetGadgetState(#CheckBox_0)
    If GetGadgetState(#CheckBox_4)
      temp=temp+"i8x8,"
    EndIf
    temp.s=" --8x8dct"+temp.s
  EndIf
  If GetGadgetState(#CheckBox_5)
    temp=temp+"i4x4,"
  EndIf
  If temp=""
    temp="none"
  Else
    temp=Mid(temp,1,Len(temp)-1)
  EndIf
  ProcedureReturn temp.s
EndProcedure

Procedure.s addanalysesfast()
  temp.s=" -A "
  If GetGadgetState(#CheckBox_1)
    temp=temp+"p8x8,"
  EndIf
  If GetGadgetState(#CheckBox_5)
    temp=temp+"i4x4,"
  EndIf
  If temp=""
    temp="none"
  Else
    temp=Mid(temp,1,Len(temp)-1)
  EndIf
  ProcedureReturn temp.s
EndProcedure

Procedure.s addbitrate(sfn.s,sim.l)
  If sim=0
    ProcedureReturn " -B "+GetGadgetText(#String_2)
  Else
    ;The way to calculate bitrate is from buzzqw's MkvMagic at first!
    mop=LoadMovie(#PB_Any,sfn.s)
    If mop    
      fr.l=MovieLength(mop)
      fps.f=MovieInfo(mop,0)
      dur.l=fr.l/fps.f
      fsb.l=ValF(GetGadgetText(#String_2))*1024*1024*8
      If GetGadgetState(#check_a)
        afs.l=dur.l*Val(GetGadgetText(#String_a))*1024
      Else
        afs.l=0
      EndIf
      vfs.l=(fsb-afs)/dur/1002
      ProcedureReturn " -B "+Str(vfs.l)
    EndIf
    FreeMovie(mop)
  EndIf
EndProcedure

Procedure.s addqlimit(qp)
  temp.s=" --qpmin "+GetGadgetText(#String_7)
  temp.s=temp.s+" --qpmax "+GetGadgetText(#String_8)
;  If qp=1
    temp.s=temp.s+" --qpstep "+GetGadgetText(#String_9)
    temp.s=temp.s+" --qcomp "+StrF(Val(GetGadgetText(#String_6))/100)
;  EndIf
  ProcedureReturn temp.s
EndProcedure

Procedure.s addchrome()
  If GetGadgetState(#CheckBox_11)=0
    ProcedureReturn " --no-chroma-me"
  EndIf
EndProcedure

Procedure.s addme()
  If GetGadgetState(#Combo_3)=0
    ProcedureReturn " --me dia --merange "+GetGadgetText(#String_13)
  ElseIf GetGadgetState(#Combo_3)=1
    ProcedureReturn " --me hex --merange "+GetGadgetText(#String_13)
  ElseIf GetGadgetState(#Combo_3)=2
    ProcedureReturn " --me umh --merange "+GetGadgetText(#String_13)
  ElseIf GetGadgetState(#Combo_3)=3
    ProcedureReturn " --me esa --merange "+GetGadgetText(#String_13)
  Else 
    ProcedureReturn " --me tesa --merange "+GetGadgetText(#String_13)
  EndIf
EndProcedure

Procedure.s addmefast()
  If GetGadgetState(#Combo_3)=0
    ProcedureReturn " --me dia --merange "+GetGadgetText(#String_13)
  Else
    ProcedureReturn " --me hex --merange "+GetGadgetText(#String_13)
  EndIf
EndProcedure

Procedure.s addar()
  ProcedureReturn " --sar "+Trim(GetGadgetText(#string_15))+":"+Trim(GetGadgetText(#String_16))
EndProcedure

Procedure.s addmotion()
  temp.s=" -m "+Str(GetGadgetState(#combo_2) + 1)
  ProcedureReturn temp.s
EndProcedure

Procedure.s addmotionfaster()
  If GetGadgetState(#combo_2)>2
    temp.s=" -m 3"
  Else
    temp.s=" -m "+Str(GetGadgetState(#combo_2) + 1)
  EndIf
  ProcedureReturn temp.s
EndProcedure

Procedure.s addmotionfast()
  If GetGadgetState(#combo_2)>5
    temp.s=" -m 6"
  Else
    temp.s=" -m "+Str(GetGadgetState(#combo_2) + 1)
  EndIf
  ProcedureReturn temp.s
EndProcedure

Procedure.s addpfpdctdmrfti()
  temp.s=""
  If GetGadgetState(#checkbox_fastpskip) = 0
    temp.s=temp.s+" --no-fast-pskip"
  EndIf
  If GetGadgetState(#checkbox_dctd) = 0
    temp.s=temp.s+" --no-dct-decimate"
  EndIf
  If GetGadgetState(#check_apin)=1
    temp.s=temp.s+" --thread-input"
  EndIf
  If GetGadgetState(#CheckBox_12)=1 And Val(GetGadgetText(#String_14))>1
    temp.s=temp.s+" --mixed-refs"
  EndIf
  ProcedureReturn temp.s
EndProcedure

Procedure.s addsc()
  temp.s=" --scenecut "+GetGadgetText(#String_10)
  temp.s=temp.s+" -I "+GetGadgetText(#String_12)
  temp.s=temp.s+" -i "+GetGadgetText(#String_11)
  ProcedureReturn temp.s
EndProcedure

Procedure.s addcabac()
  temp.s=""
  If GetGadgetState(#CheckBox_13)=0
    temp.s=temp.s+" --no-cabac"
  Else
    If Not (GetGadgetState(#combo_trellis)=0)
    temp.s=temp.s+" -t "+GetGadgetText(#combo_trellis)
    EndIf
  EndIf
  ProcedureReturn temp.s
EndProcedure

Procedure.s addcabacfast()
  temp.s=""
  If GetGadgetState(#CheckBox_13)=0
    temp.s=temp.s+" --no-cabac"
  EndIf
  ProcedureReturn temp.s
EndProcedure

Procedure.s addth()
  If Val(GetGadgetText(#String_17))=0
    temp.s=" --threads "+"auto"
  Else
    temp.s=" --threads "+GetGadgetText(#String_17)
  EndIf
  ProcedureReturn temp.s
EndProcedure

Procedure.s addref()
  temp.s=" -r "+GetGadgetText(#String_14)
  ProcedureReturn temp.s
EndProcedure

Procedure.s addnr()
  ProcedureReturn " --nr "+GetGadgetText(#String_18)
EndProcedure

Procedure.s adddf()
  If GetGadgetState(#checkbox_15)=1
    ProcedureReturn " -f "+Trim(GetGadgetText(#Text_27))+":"+Trim(GetGadgetText(#Text_28))
  Else
    ProcedureReturn " --no-deblock"
  EndIf
EndProcedure

Procedure.s addbf()
  temp.s=" -b "+GetGadgetText(#String_0)
  If Val(GetGadgetText(#String_0))>0
    temp.s=temp.s+" --direct "+Chr(34)+LCase(GetGadgetText(#combo_0))+Chr(34)
    If GetGadgetState(#CheckBox_8)=0
        temp.s=temp.s+" --b-adapt 0"
      Else
        If GetGadgetState(#Bf_adapt_slow)=0
          temp.s=temp.s+" --b-adapt 1"
        Else
          temp.s=temp.s+" --b-adapt 2"
        EndIf
    EndIf
    temp.s=temp.s+" --b-bias "+GetGadgetText(#String_1)
    If GetGadgetState(#CheckBox_6)=1
      temp.s=temp.s+" --b-pyramid"
    EndIf
    If GetGadgetState(#CheckBox_9)=1
      temp.s=temp.s+" -w"
    EndIf
  EndIf
  ProcedureReturn temp.s
EndProcedure

Procedure.s addvbv(iscrf.l)
  temp.s=""
  If iscrf.l=0
    temp.s=temp.s+" --ratetol "+StrF(Val(GetGadgetText(#String_bv))/100)
  EndIf
  temp.s=temp.s+" --vbv-init "+GetGadgetText(#String_vib)
  If ValF(GetGadgetText(#String_vbs))<>0
    temp.s=temp.s+" --vbv-bufsize "+GetGadgetText(#String_vbs)
  EndIf
  If ValF(GetGadgetText(#String_vmb))<>0
    temp.s=temp.s+" --vbv-maxrate "+GetGadgetText(#String_vmb)
  EndIf
  ProcedureReturn temp.s
EndProcedure

Procedure.s addaq()
  temp.s=""
  temp.s=temp.s+" --aq-mode "+Str(GetGadgetState(#combo_aq))
  If GetGadgetState(#combo_aq)
    temp.s=temp.s+" --aq-strength "+GetGadgetText(#String_aq1)
  EndIf
  ProcedureReturn temp.s
EndProcedure

Procedure.s adddz()
  temp.s=""
  temp.s=temp.s+" --deadzone-inter "+GetGadgetText(#String_deadzone_inter)
  temp.s=temp.s+" --deadzone-intra "+GetGadgetText(#String_deadzone_intra)
  ProcedureReturn temp.s
EndProcedure

Procedure.s adddirectpm()
  ;temp.s=""
  ;temp.s=temp.s+" --direct-8x8 "+Str(1-GetGadgetState(#combo_directpm))
  ;ProcedureReturn temp.s
  ProcedureReturn ""
EndProcedure

Procedure.s addchromaqpoffset()
  temp.s=""
  temp.s=temp.s+" --chroma-qp-offset "+GetGadgetText(#string_chromaqpoffset)
  ProcedureReturn temp.s
EndProcedure

Procedure.s addlevel()
  temp.s = ""
  level = GetGadgetState(#combo_level)
  Select level
    Case 0
    Case 1
      temp.s = " --level 1"
    Case 2
      temp.s = " --level 1.1"
    Case 3
      temp.s = " --level 1.2"
    Case 4
      temp.s = " --level 1.3"
    Case 5
      temp.s = " --level 2"
    Case 6
      temp.s = " --level 2.1"
    Case 7
      temp.s = " --level 2.2"
    Case 8
      temp.s = " --level 3"
    Case 9
      temp.s = " --level 3.1"
    Case 10
      temp.s = " --level 3.2"
    Case 11
      temp.s = " --level 4"
    Case 12
      temp.s = " --level 4.1"
    Case 13
      temp.s = " --level 4.2"
    Case 14
      temp.s = " --level 5"
    Case 15
      temp.s = " --level 5.1"
  EndSelect
  ProcedureReturn temp.s
EndProcedure

Procedure.s addpsyrd()
  temp.s = ""
  temp.s = temp.s + " --psy-rd "+ GetGadgetText(#String_psyrd_rdo) + ":" + GetGadgetText(#String_psyrd_trellis)
  ProcedureReturn temp.s
EndProcedure
; IDE Options = PureBasic 4.30 (Windows - x86)
; CursorPosition = 286
; FirstLine = 278
; Folding = ------